#include<stdio.h>
#include<iostream>
using std::cout;
using std::cin;
main()
{
    int n=0,k=0;
	cin>>n>>k;
    int i=0,j=0;
    int niz[n][n];
    for(i=0;i<n;i++)
	{
		for(j=0;j<n;j++)
		{
			cin>>niz[i][j];
		}
	}
    int rez=0;
    int ukupanbroj[k];
    int brojpravouganika[k];
    for (int p=0;p<k;p++)
    {
        ukupanbroj[p]=0;
    }
    for (int p=0;p<k;p++)
    {
        brojpravouganika[p]=0;
    }
    for (int p=0;p<k;p++)
    {
	    for (i=0;i<n;i++)
	    {
	        for (j=0;j<n;j++)
	        {
	            if (p==niz[i][j])
	            {
	                ukupanbroj[p]++;
	            }
	        }
	    }
	}
    for (int p=0;p<k;p++)
    {
        int prvap=0;
        int slpojava=0;
        int prvi=0;
        for (i=0;i<n;i++)
        {
        	if(i>0 && p==niz[i][prvi] && p!=niz[i-1][prvi])
            {
                break;
            }
            if (i>0 && p==niz[i][prvi] && p==niz[i-1][prvi])
            {
                slpojava=1;
            }
            for (j=prvi;j<n;j++)
            {
                if (p==niz[i][j] && prvap==0)
                {
                	brojpravouganika[p]++;
                    prvi=j;
                    prvap=1;
                }
                else if(prvap==1 && j>0 && p==niz[i][j] && p==niz[i][j-1])
                {
                    brojpravouganika[p]++;
                }
                else if(prvap==1 && slpojava==0 && j>0 && p==niz[i][j] && p!=niz[i][j-1])
                {
                    break;
                }
                else if (prvap==1 && slpojava==1 && j>0 && p==niz[i][j])
                {
                    slpojava=2;
                    brojpravouganika[p]++;
                }
                else if (prvap==1 && slpojava==2 && j>0 && p == niz[i][j] && p!=niz[i][j-1])
                {
                    	brojpravouganika[p]++;
                }
            }
        }
    }
    for (int p=0;p<k;p++)
    {
        if (ukupanbroj[p]==brojpravouganika[p] && ukupanbroj[p]!=0)
            {
                rez++;
            }
    }
    cout<<rez;
}